from app import hashids, socketio
from app.decorators import socketio_login_required
from app.models import TesseractOCRModel, TranskribusHTRModel, User
from flask_login import current_user
from flask_socketio import join_room


@socketio.on('users.user.get')
@socketio_login_required
def users_user_get(user_hashid):
    user_id = hashids.decode(user_hashid)
    user = User.query.get(user_id)
    if user is None:
        return {'code': 404, 'msg': 'Not found'}
    if not (user == current_user or current_user.is_administrator):
        return {'code': 403, 'msg': 'Forbidden'}
    # corpora = [x.to_dict() for x in user.corpora]
    # jobs = [x.to_dict() for x in user.jobs]
    # transkribus_htr_models = TranskribusHTRModel.query.filter(
    #     (TranskribusHTRModel.shared == True) | (TranskribusHTRModel.user == user)
    # ).all()
    # tesseract_ocr_models = TesseractOCRModel.query.filter(
    #     (TesseractOCRModel.shared == True) | (TesseractOCRModel.user == user)
    # ).all()
    # response = {
    #     'code': 200,
    #     'msg': 'OK',
    #     'payload': {
    #         'user': user.to_dict(),
    #         'corpora': corpora,
    #         'jobs': jobs,
    #         'transkribus_htr_models': transkribus_htr_models,
    #         'tesseract_ocr_models': tesseract_ocr_models
    #     }
    # }
    join_room(f'users.{user.hashid}')
    return {
        'code': 200,
        'msg': 'OK',
        'payload': user.to_dict(backrefs=True, relationships=True)
    }
